//
//  MyController.m
//  sprachausgabe
//
//  Created by Holger Hinzberg on 31.08.09.
//  Copyright 2009 Cocoa-Coding. All rights reserved.
//

#import "MyController.h"

@implementation MyController

-(void)awakeFromNib
{
    NSArray *voices = [NSSpeechSynthesizer availableVoices];
	for (int i = 0; i < [voices count] - 1 ; i++)
	{
		NSString * voiceIdentifier;
		voiceIdentifier = [voices objectAtIndex:i];
		NSString *voiceName = [[NSSpeechSynthesizer attributesForVoice:
								voiceIdentifier] valueForKey:NSVoiceName];
		[voicesCombo addItemWithObjectValue:voiceName];
	}
	[voicesCombo selectItemAtIndex:0]; 
		
	[silenceButton setEnabled:FALSE];
	mySpeechSynth = [[NSSpeechSynthesizer alloc] initWithVoice:nil];
	[mySpeechSynth setDelegate:self];
}

- (IBAction)speak:(id)sender
{
    [speakButton setEnabled:FALSE];
	[silenceButton setEnabled:TRUE];
	
	[mySpeechSynth setVoice:[[NSSpeechSynthesizer availableVoices]
	objectAtIndex:[voicesCombo indexOfSelectedItem]]]; 
	
	NSString *aText = [[inputTextView textStorage] string];
    [mySpeechSynth startSpeakingString:aText];
}

- (IBAction)silence:(id)sender
{
    [speakButton setEnabled:TRUE];
	[silenceButton setEnabled:FALSE];
    [mySpeechSynth stopSpeaking];
}

-(void)speechSynthesizer:(NSSpeechSynthesizer *)sender didFinishSpeaking:
(BOOL) finishedSpeaking
{
    [speakButton setEnabled:TRUE];
	[silenceButton setEnabled:FALSE];
}

-(IBAction)saveToFile:(id)sender
{
	NSSavePanel *mySavePanel = [NSSavePanel savePanel];
    [mySavePanel setRequiredFileType:@"aiff"];
    [mySavePanel setTitle:@"Sprachausgabe speichern"];
	
    if([mySavePanel runModal] == NSOKButton)
	{
		NSString *myText;
		myText = [[inputTextView textStorage] string];
		
		[mySpeechSynth setVoice:[[NSSpeechSynthesizer availableVoices]
		objectAtIndex:[voicesCombo indexOfSelectedItem]]];
		
		NSURL *myURL = [NSURL URLWithString:[mySavePanel filename] ];
		
		[mySpeechSynth startSpeakingString:myText toURL:myURL];		
	}
}

@end 
